Index: main/trunk/greenstone3/web/interfaces/oran/style/core.css
===================================================================
--- main/trunk/greenstone3/web/interfaces/oran/style/core.css	(revision 25005)
+++ main/trunk/greenstone3/web/interfaces/oran/style/core.css	(revision 25006)
@@ -5,7 +5,5 @@
 body {
 	font-family: sans-serif;
-	padding: 20px;
 	margin: 0;
-	color: #444;
 	background-color: #eae4d9;
 }
@@ -80,4 +78,5 @@
 	cursor:pointer;
 	padding:2px;
+	border:0px;
 }
 
@@ -132,20 +131,48 @@
 	line-height: 120%;
 	background-color: #fff;
-	border: 1px solid #c8c3b9;
+	border-top-width: 0px;
+}
+
+#topArea {
+	border-bottom-width: 0px;
+	max-width: 998px;
+	margin: 20px auto 0;
+}
+
+#topArea table {
+	width: 100%;
+}
+
+#topArea td {
+	width: 50%;
 }
 
 #gs_banner {
-	/*background: transparent url('../images/gsdlhead.gif') scroll no-repeat left top;*/
-	background-color: #008800;
-	padding: 10px 20px 30px 20px;
-	min-height: 80px;
+	padding:0px;
+	height:100px;
 	position: relative;
 }
 
 #gs_content {
-	padding: 1em;
-	padding-right: 2em;
+	margin-top:-10px;
+	padding: 20px 20px 10px;
 	min-height: 300px;
 	/* background-color: #ff0; */
+}
+
+#gs_footer {
+	position: relative;
+	display: block;
+	/*background: transparent url('../images/gsdlhead.gif') scroll no-repeat left top;*/
+	margin: -1px auto;
+	text-align: center;
+	vertical-align: middle;
+	font-size: 70%;
+	padding-top:5px;
+	padding-bottom:5px;
+}
+
+#gs_footer a {
+	/*color:#FFF;*/
 }
 
@@ -165,5 +192,4 @@
 .viewOptions {
 	width: 100%;
-	background:#008800;
 }
 
@@ -172,6 +198,10 @@
 }
 
+.tableOfContentsTitle{
+	font-weight:bold;
+	text-align:left;
+}
+
 .viewOptions a:link, .viewOptions a:hover, .viewOptions a:active, .viewOptions a:visited {
-	color:white;
 	text-decoration:none;
 }
@@ -179,9 +209,9 @@
 #rightSidebar {
 	border: 1px solid #cdc;
-	width: 25%;
-	min-width: 180px;
-	float: right;
+	width: 30%;
+	min-width:180px;
+	float:right;
 	margin: 0 0 10px 20px;
-	/* background-color: #f0f; */
+	background-color: #FFFFFF;
 }
 
@@ -189,8 +219,4 @@
 	padding:10px;
 }
-
-#quickSearch {
-}
-
 
 #collectionLinks {
@@ -213,23 +239,4 @@
 }
 
-#gs_footer {
-	position: relative;
-	display: block;
-	background: transparent url('../images/gsdlhead.gif') scroll no-repeat left top;
-	margin: 0 auto;
-	text-align: center;
-	vertical-align: middle;
-	font-size: 70%;
-	color: #fff;
-	padding-top:5px;
-	padding-bottom:5px;
-}
-
-#gs_footer a {
-	color:#FFF;
-}
-
-
-
 /* some text should not be rendered as it is just there for search engines */
 #collectionLinks a b {
@@ -239,5 +246,5 @@
 /* make sure h1s and h2s are readable on the green banner */
 #breadcrumbs, #gs_banner h2, #breadcrumbs a, #gs_banner h2 a {
-	color: #fff;
+	/*color: #fff;*/
 }
 body.dAction #gs_banner h2 {
@@ -247,110 +254,76 @@
 
 #titlearea {
-	padding-left: 1em;
-	padding-right: 1em;
-	height:60px;
-	background-color: #007200;
+	padding-left: 20px;
 	width:40%;
 }
 
-#titlesearchcontainer {
-	width:100%;
-	margin: 5px 0 5px;
+#titlesearchcontainer {	
+	height: 70px;
+	width: 100%;
+}
+
+#titlesearchcontainer h2 {	
+	padding-left: 0px;
+}
+
+#titlesearchcontainer, #titlesearchcontainer form, #titlesearchcontainer h2{
+	padding-top: 0px;
+	padding-bottom: 0px;
+	margin-top: 0px;
+	margin-bottom: 0px;
 }
 
 #quicksearcharea {
-	width:60%;
-	text-align:right;
-	padding: 0.4em;
-	color:white;
-	background-color:#007200;
-}
-
-#quicksearcharea table{
-	font-size:70%; 
-	margin:0; 
-	float: right;
+	width: 60%;
+	text-align: right;
+	padding-right: 20px;
+	padding-top: 10px;
+}
+
+#quicksearcharea ul{
+	margin:0;
+}
+
+#quicksearcharea li{
+	display:inline;
+	list-style:none;
+	margin-left:5px; 
+	padding: 2px 3px 2px 5px;
+	font-size: 10px;
 }
 
 #quicksearcharea a{
-	color:white; 
 	text-transform:lowercase;
-	padding-left:10px; 
 }
 
 #breadcrumbs {
-	/*margin: 0 0 10px 0;*/
-	height: 25px;
-	line-height: 15px;
-}
-
-/* css to make the tabs work */
-#nav {
-	position:absolute;
-	width: auto;
-	bottom: 0;
-	left: 0;
-	list-style: none;
-	margin:0;
-	padding: 0 0 0 20px;
-	font-size: 14px;
-}
-
-#nav li {
-	float: left;
-	color: #fff;
-	background: transparent url('../images/tab-right.png') scroll no-repeat 100% -100px;
-	margin: 0 5px 0 0;
-	padding: 0 8px 0 0;
-	text-transform: capitalize;
-}
-
-#nav a{
-
-	display: block;
-	float:left;
-	background: transparent url('../images/tab-left.png') no-repeat scroll 0 -100px;
-	margin:0;
-	padding: 5px 4px 3px 10px;
-	font-weight: bold;
-	color: #fff;
-	text-decoration: none;
-	line-height: 1;
-}
-
-#nav li:hover, #nav li.current { background-position: 100% 0; }
-#nav li:hover a, #nav li.current a { background-position: 0 0; cursor:default; }
+	margin-left: 20px;
+}
+
+#breadcrumbs a{
+	text-decoration:underline;
+}
 
 
 /* css to make the page links work (home, help, preference) */
 #bannerLinks {
-	width: auto;
-	position: absolute;
+	text-align: right;
 	list-style: none;
-	margin:0;
-	top: 7px;
-	right: 0;
-	padding: 0 15px 0 0;
-	text-transform: lowercase;
+	margin: 0 20px;
+	text-transform: capitalize;
+	font-size: 14px;
 }
 
 #bannerLinks li {
-	float: right;
-	margin: 0;
-	padding: 0 2px 0 0;
-}
-
-#bannerLinks a {
-	display: block;
-	float: left;
-	display: table-cell;
-	min-width: 1em;
-	margin:0;
-	padding: 5px 5px 3px 10px;
-	font-weight: normal;
-	text-align: center;
-	color: #fff;
-	text-decoration: none;
-	line-height: 1;
+	/*display: inline;*/
+	float:right;
+	margin-left: 5px;
+	padding: 1px 4px 1px 0px;
+}
+
+#bannerLinks ul {
+	padding: 0px 3px 0px 0px;
+	text-align: right;
+	list-style: none;
 }
 
@@ -403,4 +376,35 @@
 	cursor: default;
 }
+
+/* css to make the tabs work */
+#nav {
+	list-style: none outside none;
+	padding: 0px;
+	margin: 9px 0 0 20px;
+	font-size: 14px;
+}
+
+#nav ul {
+	margin:0px;
+	padding:0px;
+}
+
+#nav li {
+	display: inline;
+	margin-right: 5px;
+	padding: 3px 5px 4px 7px;
+	text-transform: capitalize;
+	text-align: center;
+	border-bottom: none;
+}
+
+#nav a{
+	margin:0px;
+	font-weight: bold;
+	text-decoration: none;
+}
+
+#nav li:hover, #nav li.current { background-position: 100% 0; }
+#nav li:hover a, #nav li.current a { background-position: 0 0; cursor:default; }
 
 /* style the search and classifier results */
@@ -466,5 +470,5 @@
 
 
-a:link, a:hover, a:active, a:visited { color: #050; }
+/*a:link, a:hover, a:active, a:visited { color: #050; }*/
 
 /* bg image set in style macro */
@@ -666,4 +670,38 @@
 }
 
+/* ------- PAGED IMAGE ------- */
+
+.pageSlider {
+	width: 250px;
+	overflow: auto;
+	margin-left: auto;
+	margin-right: auto;
+	background: #BBFFBB;
+	border:2px solid #00AA00;
+	padding: 2px;
+}
+
+.pageSliderSpacer {
+	width:2px;
+}
+
+.pageSliderCol {
+	width:75px;
+	height:100px;
+	margin: 3px;
+	text-align: center;
+}
+
+/* ------- SPATIAL COLLECTIONS ------- */
+
+#nearbyDocs td, #nearbyDocs th {
+	padding: 5px;
+	border: 1px solid black;
+}
+
+#nearbyDocs th {
+	font-weight: bold;
+}
+
 /*
 ul.childrenlist li {